package de.fhmuenster.masterthesis.generator;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import de.fhmuenster.masterthesis.generator.mockdata.IsMock;

public class BPMNGenTestcase {

	private String name;
	private BPMNGenFlow flow;
	private List<TaskVariables> taskVariableMap;
	private HashMap<String, VariableCheck> endCheckVariableMap;
	private HashMap<String, HashMap<String, Object>> globalTaskVariableMap;
	private Map<String, String> globalExternalTopicsMap;
	private List<IsMock> mocks;
	
	public BPMNGenTestcase() {
		this.taskVariableMap = new ArrayList<>();
		this.endCheckVariableMap = new HashMap<>();
		this.globalTaskVariableMap = new HashMap<>();
		this.globalExternalTopicsMap = new HashMap<>();
		this.mocks = new ArrayList<>();
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public BPMNGenFlow getFlow() {
		return flow;
	}
	
	public void setFlow(BPMNGenFlow flow) {
		this.flow = flow;
	}

	public List<TaskVariables> getTaskVariableMap() {
		return taskVariableMap;
	}
	
	public void setTaskVariableMap(List<TaskVariables> taskVariableMap) {
		this.taskVariableMap = taskVariableMap;
	}
	
	public HashMap<String, VariableCheck> getEndCheckVariableMap() {
		return endCheckVariableMap;
	}
	
	public void setEndCheckVariableMap(HashMap<String, VariableCheck> endCheckVariableMap) {
		this.endCheckVariableMap = endCheckVariableMap;
	}
	
	public void putEndCheckVariable(String variable, VariableCheck variableCheck) {
		this.endCheckVariableMap.put(variable, variableCheck);
	}
	
	public HashMap<String, HashMap<String, Object>> getGlobalTaskVariableMap() {
		return globalTaskVariableMap;
	}
	
	public void setGlobalTaskVariableMap(HashMap<String, HashMap<String, Object>> taskVariableMap) {
		this.globalTaskVariableMap = taskVariableMap;
	}
	
	public void putGlobalTaskVariable(String task, String variableKey, Object variableValue) {
		HashMap<String, Object> taskVariables = globalTaskVariableMap.getOrDefault(task, new HashMap<>());
		taskVariables.put(variableKey, variableValue);
		globalTaskVariableMap.put(task, taskVariables);
	}
	
	public Map<String, String> getGlobalExternalTopicsMap() {
		return globalExternalTopicsMap;
	}
	
	public void setGlobalExternalTopicsMap(Map<String, String> globalExternalTopicsMap) {
		this.globalExternalTopicsMap = globalExternalTopicsMap;
	}
	
	public List<IsMock> getMocks() {
		return mocks;
	}
	
	public void setMocks(List<IsMock> mocks) {
		this.mocks = mocks;
	}
	
	public void addMock(IsMock mock) {
		this.mocks.add(mock);
	}
}
